"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

exports.__esModule = true;
exports["default"] = void 0;

var React = _interopRequireWildcard(require("react"));

var _isFunction = _interopRequireDefault(require("lodash/isFunction"));

var _get = _interopRequireDefault(require("lodash/get"));

var _isNullOrUndefined = _interopRequireDefault(require("./isNullOrUndefined"));

function cloneCell(Cell, props) {
  return React.cloneElement(Cell, props);
}

function colSpanCells(cells) {
  var nextCells = [];

  for (var i = 0; i < cells.length; i += 1) {
    var _cells$i$props = cells[i].props,
        width = _cells$i$props.width,
        colSpan = _cells$i$props.colSpan;
    /**
     * 如果存在 colSpan 属性，就去找它的下一个 Cell,
     * 看看值是否是 isNullOrUndefined，，如果为空这可以合并这个单元格
     */

    if (colSpan) {
      var nextWidth = width;

      for (var j = 0; j < colSpan; j += 1) {
        var nextCell = cells[i + j];

        if (nextCell) {
          var _nextCell$props = nextCell.props,
              rowData = _nextCell$props.rowData,
              rowIndex = _nextCell$props.rowIndex,
              children = _nextCell$props.children,
              colSpanWidth = _nextCell$props.width,
              isHeaderCell = _nextCell$props.isHeaderCell,
              dataKey = _nextCell$props.dataKey;
          var cellText = (0, _isFunction["default"])(children) ? children(rowData, rowIndex) : (0, _get["default"])(rowData, dataKey);

          if (rowData && (0, _isNullOrUndefined["default"])(cellText) || isHeaderCell && (0, _isNullOrUndefined["default"])(children)) {
            nextWidth += colSpanWidth;
            cells[i + j] = cloneCell(nextCell, {
              removed: true
            });
          }
        }
      }

      nextCells.push(cloneCell(cells[i], {
        width: nextWidth
      }));
      continue;
    }

    nextCells.push(cells[i]);
  }

  return nextCells;
}

var _default = colSpanCells;
exports["default"] = _default;
module.exports = exports.default;